package com.kasetoatz.boatjump.mixin;

import com.kasetoatz.boatjump.BoatJump;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.vehicle.AbstractBoatEntity;
import net.minecraft.entity.vehicle.VehicleEntity;
import net.minecraft.world.World;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;


@Mixin(AbstractBoatEntity.class)
public abstract class BoatEntityMixin extends VehicleEntity {
    @Shadow private AbstractBoatEntity.Location location;

    public BoatEntityMixin(EntityType<?> entityType, World world) {
        super(entityType, world);
    }

    @Inject(method="tick", at=@At("HEAD"))
    public void tick(CallbackInfo ci) {
        if (this.getControllingPassenger() == BoatJump.client.player && this.location == AbstractBoatEntity.Location.IN_WATER) {
            this.setOnGround(true);
        }
    }
}
